//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  hbv_EXg TStringGrid R|[lg
//  NXTplDropStringGrid
//  ɃCvCXGfB^̑pCxgǉTStringGrid
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2014N1209 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plDropStringGrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Grids, StdCtrls, Graphics,
  ExtCtrls, forms, Dialogs;

type
  TplDropStringGrid = class;
  TplgVertAlignment = (vaTop, vaCenter, vaBottom);

  //---------------------------------------------------------------------------
  //  TInplaceEdiťpNX
  //  protectedvpeBgp\ɂ
  //  TInplaceEditɌXȂvpeBɃANZXƃ{^\Ȃ
  //  T[hp[eB́CvpeBݒp̃NXgpĂ悤
  //---------------------------------------------------------------------------
  TplInplaceEdit = class(TInplaceEdit)
  private
    FGrid : TplDropStringGrid;
  public
    property Alignment;
    property Font;
    property AutoSelect;
    property BorderStyle;
    property BevelEdges;
    property BevelWidth;
    property BevelOuter;
    property BevelKind;
    property BevelInner;
    property Color;
    property ImeMode;
    property ReadOnly;
  end;

  //eCxǧ^̒`
  TGetEditStyleEvent = procedure(Sender: TObject; ACol, ARow: Integer;
    var EditStyle: TEditStyle) of Object;
  TOnGridEditButtonClickEvent = procedure(Sender: TObject;
    ACol, ARow: Integer; ARect: TRect) of Object;
  TOnGridDropDownEvent = procedure(Sender: TObject;
    ACol, ARow: Integer; ARect: TRect; var DefaultAction: Boolean) of Object;
  TOnDropListClickEvent = procedure(Control: TWinControl;
    ACol, ARow: Integer; ARect: TRect; Index: Integer; ListItem: String;
    InpEdit: TplInplaceEdit) of Object;
  TOnInplaceEditCloseEvent = procedure(Sender: TObject;
    ACol, ARow: Integer; Value: String; var CanNextCell: Boolean) of Object;
  TOnInplaceCanEditShowEvent = procedure(Sender: TObject;
    ACol, ARow: Integer; ARect: TRect; InpEdit: TplInplaceEdit) of Object;
  TOnInplaceEditFocusedEvent = procedure(Sender: TObject;
    ACol, ARow: Integer; ARect: TRect; InpEdit: TplInplaceEdit) of Object;

  //---------------------------------------------------------------------------
  //  TInplaceEditListJX^}CY邽߂̌pNX
  //---------------------------------------------------------------------------
  TplInplaceEditList  = class(TInplaceEditList)
  private
    FGrid : TplDropStringGrid;
    procedure PickListDrawItemEvent(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PickListClickEvent(Sender: TObject);
  protected
    procedure CreateWnd; override;
    procedure WMMouseWheel(var Message: TWMMouseWheel); message WM_MOUSEWHEEL;
  public
    constructor Create(AOwner: TComponent); override;
    procedure DropDown; override;
  end;

  //---------------------------------------------------------------------------
  //  PickListƎQ(ȗL){^NbNTStringGrid
  //---------------------------------------------------------------------------
  TplDropStringGrid = class(TStringGrid)
  private
    FDropListRowCount     : Integer;
    FInplaceButtonWidth   : integer;
    FDropListWidth        : Integer;
    FDropListColor        : TColor;
    FDropItemHeight       : Integer;
    FOnEditButtonClick    : TOnGridEditButtonClickEvent;
    FOnGetEditStyle       : TGetEditStyleEvent;
    FOnGetPickListItems   : TOnGetPickListItems;
    FOnDropDownList       : TOnGridDropDownEvent;
    FOnDropListDrawItem   : TDrawItemEvent;
    FOnDropListClick      : TOnDropListClickEvent;
    FOnInplaceEditClose   : TOnInplaceEditCloseEvent;
    FOnInplaceImageClick  : TOnGridEditButtonClickEvent;
    FOnInplaceCanEditShow : TOnInplaceCanEditShowEvent;
    FOnInpaceEditFocused  : TOnInplaceEditFocusedEvent;

    FInpEdit      : TplInplaceEdit;
    FInplaceImage : TImage;

    FEditLeftIndent    : Integer;
    FEditRightIndent   : Integer;
    FEditVertAlignment : TplgVertAlignment;
    FEditTopIndent     : Integer;
    FEditBottomIndent  : Integer;
    FEditTextHeight    : Integer;
    FEditDefaultLeftIndent    : Integer;
    FEditDefaultRightIndent   : Integer;
    FEditDefaultTopIndent     : Integer;
    FEditDefaultBottomIndent  : Integer;
    FEditDefaultVertAlignment : TplgVertAlignment;

    FEditCol     : Integer;    //Grid.pasłInplaceColɑ
    FEditRow     : Integer;    //Grid.pasłInplaceRowɑ
    FCanCellChange     : Boolean;
    FIsParentFormClose : Boolean;
    FParentFormWndProc : TWndMethod;

    procedure SetDropListRowCount(Value: Integer);
    procedure SetOnEditButtonClick(Value: TOnGridEditButtonClickEvent);
    procedure SetOnGetPicklistItems(Value: TOnGetPickListItems);
    procedure SetInplaceButtonWidth(const Value: Integer);
    procedure ButtonClick(Sender: TObject);
    procedure ImageButtonClick(Sender: TObject);
    procedure SetOnDropListDrawItem(const Value: TDrawItemEvent);
    procedure SetOnDropListClick(const Value: TOnDropListClickEvent);
    procedure SubClassFormProc(var Message: TMessage);
    procedure SetIndentAndVertAlignment;
  protected
    function  CreateEditor: TInplaceEdit; override;
    function  GetEditStyle(ACol, ARow: Integer): TEditStyle; override;
    procedure SetParent(AParent: TWinControl); override;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND;
    procedure WMLButtonUp(var Message: TWMLButtonUp); message WM_LBUTTONUP;
    function CanEditShow: Boolean; override;
    function SelectCell(ACol: Integer; ARow: Integer): Boolean; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    property InplaceEditor      : TplInplaceEdit read FInpEdit;
    property InplaceImage       : TImage  read FInplaceImage   write FInplaceImage;
    property DropListWidth      : Integer read FDropListWidth  write FDropListWidth;
    property DropListColor      : TColor  read FDropListColor  write FDropListColor;
    property DropListItemHeight : Integer read FDropItemHeight write FDropItemHeight;
    property InplaceButtonWidth : Integer read FInplaceButtonWidth
                                          write SetInplaceButtonWidth;
    //TInplaceEditɂȂvpeB
    //CvCXGfB^̏㉺̃ACgƍẼCfg
    property EditLeftIndent : Integer
      read FEditLeftIndent  write FEditLeftIndent;
    property EditRightIndent : Integer
      read FEditRightIndent write FEditRightIndent;
    property EditVertAlignment : TplgVertAlignment
      read FEditVertAlignment  write FEditVertAlignment;
    property EditDefaultLeftIndent    : Integer        read FEditDefaultLeftIndent;
    property EditDefaultRightIndent   : Integer        read FEditDefaultRightIndent;
    property EditDefaultVertAlignment : TplgVertAlignment read FEditDefaultVertAlignment;
  published
    property DropListRowCount : Integer
      read FDropListRowCount write SetDropListRowCount;
    property OnEditButtonClick: TOnGridEditButtonClickEvent
      read FOnEditButtonClick write SetOnEditButtonClick;
    property OnGetEditStyle : TGetEditStyleEvent
      read FOnGetEditStyle write FOnGetEditStyle;
    property OnGetPickListItems : TOnGetPickListItems
      read FOnGetPickListItems write SetOnGetPickListItems;
    property OnDropDownList: TOnGridDropDownEvent
      read FOnDropDownList write FOnDropDownList;
    property OnDropListDrawItem: TDrawItemEvent
      read FOnDropListDrawItem write SetOnDropListDrawItem;
    property OnDropListClick : TOnDropListClickEvent
      read FOnDropListClick write SetOnDropListClick;
    property OnInplaceEditClose : TOnInplaceEditCloseEvent
      read FOnInplaceEditClose write FOnInplaceEditClose;
    property OnInplaceImageClick : TOnGridEditButtonClickEvent
      read FOnInplaceImageClick write FOnInplaceImageClick;
    property OnInplaceCanEditShow : TOnInplaceCanEditShowEvent
      read FOnInplaceCanEditShow write FOnInplaceCanEditShow;
    property OnInplaceEditFocused : TOnInplaceEditFocusedEvent
      read FOnInpaceEditFocused write FOnInpaceEditFocused;
  end;

procedure Register;

implementation

uses imm;

{ TplInplaceEditList }

//-----------------------------------------------------------------------------
//  Create\bh
//-----------------------------------------------------------------------------
constructor TplDropStringGrid.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FDropListRowCount   := 8;
  FInplaceButtonWidth := 17;
  FDropListWidth      := -1;
  FDropListColor      := clWindow;
  FEditDefaultLeftIndent    := 2;
  FEditDefaultRightIndent   := 2;
  FEditDefaultTopIndent     := 2;
  FEditDefaultBottomIndent  := 2;
  FEditDefaultVertAlignment := vaTop;

  FEditLeftIndent   := FEditDefaultLeftIndent;
  FEditRightIndent  := FEditDefaultRightIndent;
  FEditTopIndent    := FEditDefaultTopIndent;
  FEditBottomIndent := FEditDefaultBottomIndent;

  FEditCol := -1;
  FEditRow := -1;
  FCanCellChange     := True;
  FIsParentFormClose := False;
end;

//-----------------------------------------------------------------------------
//  SetParent\bh
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetParent(AParent: TWinControl);
var
  LParentForm : TCustomForm;
begin
  inherited;
  if AParent = nil then exit;
  FDropItemHeight := Canvas.TextHeight('gh');

  if not Assigned(FParentFormWndProc) then begin
    LParentForm            := GetParentForm(Self);
    FParentFormWndProc     := LParentForm.WindowProc;
    LParentForm.WindowProc := SubClassFormProc;
  end;
end;

//-----------------------------------------------------------------------------
//  Destory\bh
//  LParentForm(etH[)̓[JŌoĎgp
//  O[oɂĂ܂Assignedł̌ołȂꍇ
//-----------------------------------------------------------------------------
destructor TplDropStringGrid.Destroy;
var
  LParentForm : TCustomForm;
begin
  //ɖ߂ĂȂƐetH[̓삪Ȃ
  LParentForm := GetParentForm(Self);
  if Assigned(LParentForm) then begin
    LParentForm.WindowProc := FParentFormWndProc;
  end;
  inherited;
end;

//-----------------------------------------------------------------------------
//  etH[̃TuNX
//  {R|zuĂtH[鎞̏p
//  etH[鎞
//  eOnCloseQueryCxgݒ肳Ă΂ɏ]
//  eOnCloseQueryCxgȂ΃ZҏWĨCxg͎sȂ
//-----------------------------------------------------------------------------
type
  TplForm = class(TCustomForm);

procedure TplDropStringGrid.SubClassFormProc(var Message: TMessage);
var
  LParentForm : TCustomForm;
begin
  LParentForm := GetParentForm(Self);

  if (Message.Msg = WM_CLOSE) then begin
    if Assigned(TplForm(LParentForm).OnCloseQuery) then begin
      FIsParentFormClose := False;
      EditorMode := False;
      EditorMode := True;
      if LParentForm.CloseQuery then begin
        FIsParentFormClose := True;
      end else begin
        FIsParentFormClose := False;
        exit;
      end;
    end;
  end;

  //̃EBhEvV[W[s
  FParentFormWndProc(Message);
  if (Message.Msg = WM_CLOSE) then begin
    if not Assigned(TplForm(LParentForm).OnCloseQuery) then begin
      FIsParentFormClose := True;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  TplStringGridCreateEditor\bh
//  CvCXGfB^鎞ɎIɎs郁\bh
//  TplInplaceEditList̃XX^X𐶐
//
//  CvCXGfB^́C߂ăZҏW鎞ɐ
//  ̎ɂ̃\bhs
//  Ȍ͕\E\̏Ԃ̐؂芷ƂȂ
//  āCTplInplaceEditList.CreateWndŏɎs邾
//-----------------------------------------------------------------------------
function TplDropStringGrid.CreateEditor: TInplaceEdit;
begin
  //TInplaceEditɃANZXł悤FInplaceEditorݒ
  Result := TInplaceEdit(TplInplaceEditList.Create(Self));
  FInpEdit := TplInplaceEdit(Result);
  FInpEdit.FGrid := Self;

  with TplInplaceEditList(Result) do begin
    if FInplaceButtonWidth > 0 then ButtonWidth  := FInplaceButtonWidth;
    if FDropListRowCount > 0   then DropDownRows := FDropListRowCount;
    OnGetPickListItems   := FOnGetPickListItems;
    OnEditButtonClick    := ButtonClick;
    //ҏW̃Z̔wiFhbv_EXg̔wiFƓɂꍇ
    //Color := FDropListColor;
  end;
end;

//-----------------------------------------------------------------------------
//  TplStringGirdGetEditStyle\bh
//  {^̃X^C肷ۂɁCIɎs郁\bh
//  Ń{^̃X^Cݒ肷
//-----------------------------------------------------------------------------
function TplDropStringGrid.GetEditStyle(ACol, ARow: Integer) : TEditStyle;
begin
  //ftHgł̓CvCXGfB^NĂ{^\Ȃ
  Result := esSimple;
  if Assigned(FOnGetEditStyle) then begin
    FOnGetEditStyle(Self, ACol, ARow, Result);
  end;
end;

//-----------------------------------------------------------------------------
//  DropList(TListBox)Ńhbv_E\鍀ڐ̐ݒp
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetDropListRowCount(Value: Integer);
begin
  FDropListRowCount := Value;
  if Assigned(FInpEdit) then begin
    TplInplaceEditList(FInpEdit).DropdownRows := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  \{^̐̕ݒp
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetInplaceButtonWidth(const Value: Integer);
begin
  FInplaceButtonWidth := Value;
  if Assigned(FInpEdit) then begin
    TplInplaceEditList(FInpEdit).ButtonWidth := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  ҏW(ȗL){^NbÑCxgݒp
//  ƍs̒lɂ邽߂ɕʂ̃Cxgݒ肵ď
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetOnEditButtonClick(Value: TOnGridEditButtonClickEvent);
begin
  FOnEditButtonClick := Value;
end;

//-----------------------------------------------------------------------------
//  ҏW(ȗL){^NbÑCxgp
//  ̃CxgŃ_CAO\
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.ButtonClick(Sender: TObject);
begin
  if Assigned(FInpEdit) then begin
    if Assigned(FOnEditButtonClick) then begin
      FOnEditButtonClick(Self, Col, Row, CellRect(Col, Row));
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  DropList(PickList)Itemݒ肷邽߂̃Cxgݒp
//  ̃CxgŃhbv_Eŕ\郊XgZbg
//  Items.Add 邢 Items.Assign()ŃZbg
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetOnGetPicklistItems(Value: TOnGetPicklistItems);
begin
  FOnGetPicklistItems := Value;
  if Assigned(FInpEdit) then begin
    TplInplaceEditList(FInpEdit).OnGetPickListitems := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  DropList(PickList)Item̃JX^`pCxg̐ݒp
//  Cxgnhnilɂ̑Ή
//  TplInplaceEditList̃CxgnhnilɂȂ
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetOnDropListDrawItem(const Value: TDrawItemEvent);
var
  LInpList : TplInplaceEditList;
begin
  FOnDropListDrawItem := Value;
  if Assigned(FInpEdit) then begin
    LInpList := TplInplaceEditList(FInpEdit);
    TListBox(LInpList.PickList).OnDrawItem := Value;
  end else begin
    FOnDropListDrawItem := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  DropList(PickList)ItemNbÑCxg̐ݒp
//  Cxgnhnilɂ̑Ή
//  TplInplaceEditList̃CxgnhnilɂȂ
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetOnDropListClick(
  const Value: TOnDropListClickEvent);
var
  LInpList : TplInplaceEditList;
begin
  FOnDropListClick := Value;
  if Assigned(FInpEdit) then begin
    LInpList := TplInplaceEditList(FInpEdit);
    if Assigned(FOnDropListClick) then begin
      LInpList.OnClick := LInpList.PickListClickEvent;
    end else begin
      LInpList.OnClick := nil;
    end;
  end else begin
    FOnDropListClick := Value;
  end;
end;

//-----------------------------------------------------------------------------
//  CvCXGfB^ɍڂĂTImageNbÑCxgp
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.ImageButtonClick(Sender: TObject);
begin
  if FInplaceImage.Visible = False then exit;
  if Assigned(FInpEdit) then begin
    if Assigned(FOnInplaceImageClick) then begin
      FOnInplaceImageClick(Self, Col, Row, CellRect(Col, Row));
      FInpEdit.SetFocus;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  SelectCell\bh
//  ̓Z̕ҏWIɎ̃ZɈړȂ悤ɂ鏈ǉ
//  ͕ҏWIp̃Cxg̈Ŏw肷
//  FIsParentFormClose̓ZҏWĨCxgsۂ̃tOƂĂp
//-----------------------------------------------------------------------------
function TplDropStringGrid.SelectCell(ACol, ARow: Integer): Boolean;
begin
  if (FCanCellChange = False) then begin
    FIsParentFormClose := True;
    Result := False;
  end else begin
    Result := inherited SelectCell(ACol, ARow);
  end;
end;

//-----------------------------------------------------------------------------
//  ҏWZ̏㉺̃ACgƍẼCfg̐ݒp
//  Z̃TCYƃtHg̃TCYvZ
//  CvCXGfB^ĂāCtHg̐ݒ肳Ă̂
//  ̏ɍ̂́COnInpaceEditFocusedCxg
//  OnGetEditTextł͑
//  OnInplaceCanEditShowł͊ɕҏWԂɓĂ܂Ă
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.SetIndentAndVertAlignment;
var
  LDevieceC   : HDC;
  LCanvas     : TCanvas;
  LCellRect   : TRect;
  LCellHeight : Integer;
begin
  if (FInpEdit <> nil) and (FInpEdit.Visible) then begin
    LCellRect := CellRect(Col, Row);
    LDevieceC := GetDC(FInpEdit.Handle);
    try
      LCanvas := TControlCanvas.Create;
      try
        LCanvas.Handle := LDevieceC;
        LCanvas.Lock;
        LCanvas.Font.Assign(FInpEdit.Font);
        FEditTextHeight := LCanvas.TextHeight('Hg');
        LCellHeight     := LCellRect.Bottom - LCellRect.Top;
        if FEditVertAlignment = vaCenter then begin
          FEditTopIndent := (LCellHeight - FEditTextHeight) div 2;
        end else
        if FEditVertAlignment = vaBottom then begin
          FEditTopIndent := LCellHeight - FEditTextHeight - FEditBottomIndent;
        end;
      finally
        LCanvas.Unlock;
        FreeAndNil(LCanvas);
      end;
    finally
      ReleaseDC(FInpEdit.Handle, LDevieceC);
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  ZҏW̒ʒmbZ[W̏
//  ʒmbZ[WEN_KILLFOCUS͈ȉ̏ꍇɔs
//  (1) [Enter]L[̉ŕҏWIꍇ
//  (2) Z̕ҏWɕʂ̃ZɈړꍇ
//
//  EN_SETFOCUSʒmbZ[W[Enter]ŕҏWԂɂꍇɔs
//  }EX{^łs
//  ŁC㉺̃ACgƍẼCfg̐ݒs
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.WMCommand(var Message: TWMCommand);
var
  LInpRect       : TRect;
  LCanCellChange : Boolean;
begin
  if (FInpEdit <> nil) and (Message.Ctl = FInpEdit.Handle) then begin
    case Message.NotifyCode of
      EN_KILLFOCUS :
      begin
        LCanCellChange := True;

        //{IME͕
        SetImeMode(FInpEdit.Handle, imClose);

        //Z̕ҏWĨCxg
        if FIsParentFormClose = False then begin
          if Assigned(FOnInplaceEditClose) then begin
            if (FEditCol = Col) and (FEditRow = Row) then begin
              FOnInplaceEditClose(Self, Col, Row, Cells[Col, Row], LCanCellChange);
              FCanCellChange := LCanCellChange;
            end;
          end;
        end;
      end;
      EN_SETFOCUS:
      begin
        //ҏW̃Z̔ԍ
        FEditCol := Col;
        FEditRow := Row;
        FCanCellChange     := True;
        FIsParentFormClose := False;

        if Assigned(FOnInpaceEditFocused) then begin
          FOnInpaceEditFocused(Self, Col, Row, CellRect(Col, Row), FInpEdit);
        end;
        SetIndentAndVertAlignment;

        //}EX{^Ƃł̐ݒ肪ɂȂĂ܂
        //ŁCWM_LBUTTONUPōĐݒsĂ
        if (FInpEdit <> nil) and (FInpEdit.Visible) then begin
          SendMessage(FInpEdit.Handle, EM_GETRECT, 0, LPARAM(@LInpRect));
          SetRect(LInpRect, FEditLeftIndent + FEditDefaultLeftIndent,
                            FEditTopIndent,
                            LInpRect.Right - FEditRightIndent,
                            FEditTopIndent + FEditTextHeight);
          SendMessage(FInpEdit.Handle, EM_SETRECTNP, 0, LPARAM(@LInpRect));
        end;
      end;
    end;

    //I̓CvCXGfB^I
    //̏ȂƃZҏW̎ɃAvIȂꍇ
    if Message.Msg = WM_DESTROY then begin
      if Assigned(FInpEdit) then begin
        FInpEdit.Destroy;
      end;
    end;
  end;

  inherited;
end;

//-----------------------------------------------------------------------------
//  ZҏWJn̍ẼCfgƏc̃ACg̐ݒ
//  [Enter]L[ŃZҏW[hɂȂꍇ͎sȂ
//-----------------------------------------------------------------------------
procedure TplDropStringGrid.WMLButtonUp(var Message: TWMLButtonUp);
var
  LInpRect : TRect;
begin
  inherited;

  if (FInpEdit <> nil) and (FInpEdit.Visible) then begin
    SendMessage(FInpEdit.Handle, EM_GETRECT, 0, LPARAM(@LInpRect));
    SetRect(LInpRect, FEditLeftIndent + FEditDefaultLeftIndent,
                      FEditTopIndent,
                      LInpRect.Right - FEditRightIndent,
                      FEditTopIndent + FEditTextHeight);
    SendMessage(FInpEdit.Handle, EM_SETRECTNP, 0, LPARAM(@LInpRect));
  end;
end;

//-----------------------------------------------------------------------------
//  CanEditShow\bh
//  ZҏW[hɂȂɎIɎs֐
//  \bhł͂ȂCxgɂ
//-----------------------------------------------------------------------------
function TplDropStringGrid.CanEditShow: Boolean;
begin
  Result := inherited CanEditShow;
  if Result = False then exit;

  if (FInpEdit <> nil) and (FInpEdit.Visible) then begin
    if Assigned(FOnInplaceCanEditShow) then begin
      FOnInplaceCanEditShow(Self, Col, Row, CellRect(Col, Row), FInpEdit);
    end;
  end;
end;

{ TplInplaceEditList }

//-----------------------------------------------------------------------------
//  TplInplaceEditListNXCreate\bh
//-----------------------------------------------------------------------------
constructor TplInplaceEditList.Create(AOwner: TComponent);
begin
  inherited;
  FGrid := TplDropStringGrid(AOwner);
end;

//-----------------------------------------------------------------------------
//  TplInplaceEditListNXCreateWnd\bh
//  PickList(TCustomListBox)̃X^CύX
//  hbv_EXg̃NXTPopUpListBox(TCustomListBox)
//
//  ItemHeight̒lύXɂ
//  (1) CreateWnd\bhStylelbOwnerDrawVariableɂ
//  (3) DropDowninherited̑OItemHeight̒lݒ肷
//  Ƃ悤ł
//
//  CreateWnd͏߂ăZҏWԂɂȂs
//-----------------------------------------------------------------------------
procedure TplInplaceEditList.CreateWnd;
begin
  inherited;

  //InplaceImage(TImage)̐
  if not Assigned(FGrid.InplaceImage) then begin
    FGrid.InplaceImage         := TImage.Create(FGrid);
    FGrid.InplaceImage.Parent  := FGrid.InplaceEditor;
    FGrid.InplaceImage.OnClick := FGrid.ImageButtonClick;
    FGrid.InplaceImage.Visible := False;
  end;

  //TPopupListbox̌pTCustomListBox
  with TListBox(PickList) do begin
    BevelKind   := bkFlat;
    BevelWidth  := 1;
    BevelInner  := bvNone;
    BevelOuter  := bvRaised;
    Style       := lbOwnerDrawVariable;

    if Assigned(FGrid.FOnDropListDrawItem) then begin
      OnDrawItem := PickListDrawItemEvent;
    end;
    if Assigned(FGrid.FOnDropListClick) then begin
      OnClick := PickListClickEvent;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  TplInplaceEditListNXDropDown\bh
//  hbv_E(){^NbNƎs郁\bh
//  PickList(TCustomListBox)̔wiFƕ̕ύX
//-----------------------------------------------------------------------------
procedure TplInplaceEditList.DropDown;
var
  LCol  : Integer;
  LRow  : Integer;
  LRect : TRect;
  Flag  : Boolean;
begin
  //Flag(DefaultActionFalseɂƃhbv_E\Ȃ
  //ʂ̃hbv_Ep̃EChEgpꍇɗp\
  Flag := True;
  LCol := FGrid.Col;
  LRow := FGrid.Row;
  if FGrid.GetEditStyle(LCol, LRow) = esPickList then begin
    if Assigned(FGrid.OnDropDownList) then begin
      FGrid.OnDropDownList(FGrid, LCol, LRow, FGrid.CellRect(LCol, LRow), Flag);
    end;
    if Flag then begin

      TListBox(PickList).BevelKind  := bkFlat;
      //ڂ̍̐ݒ
      TListBox(PickList).ItemHeight := FGrid.DropListItemHeight;

      inherited;

      //wiF
      TListBox(PickList).Color := FGrid.DropListColor;
      //̐ݒ
      LRect := FGrid.CellRect(LCol, LRow);
      if FGrid.DropListWidth <= 0 then begin
        TListBox(PickList).Width := LRect.Right - LRect.Left + 1;
      end else begin
        TListBox(PickList).Width := FGrid.DropListWidth;
      end;
    end;
  end;
end;

//-----------------------------------------------------------------------------
//  TplInplaceEditListNXPickListDrawItemEvent\bh
//  TplInplaceEditListŒǉ\bh
//  PickList(TCustomListBox)OnDrawItemCxgs
//  ̃Cxgݒ肷ƃftHg̕`͍sȂ
//  SĎOŃR[hƂɂȂ
//-----------------------------------------------------------------------------
procedure TplInplaceEditList.PickListDrawItemEvent(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  if Assigned(FGrid.FOnDropListDrawItem) then begin
    FGrid.FOnDropListDrawItem(Control, Index, Rect, State);
  end;
end;

//-----------------------------------------------------------------------------
//  TplInplaceEditListNXPickListClick\bh
//  OnDropPickListClickCxgp
//  PickList(TCustomListBox)OnClickCxgs
//
//  ȉ̑Ŕ
//  (1) [Enter]L[ŕ
//  (2) }EXNbNŕ
//  (3) L[őIڂύX
//-----------------------------------------------------------------------------
procedure TplInplaceEditList.PickListClickEvent(Sender: TObject);
var
  LCol   : Integer;
  LRow   : Integer;
  LIndex : Integer;
  LItem  : String;
begin
  if Assigned(FGrid.FOnDropListClick) then begin
    LCol   := FGrid.Col;
    LRow   := FGrid.Row;
    LIndex := TListBox(PickList).ItemIndex;
    LItem  := TListBox(PickList).Items[LIndex];
    FGrid.FOnDropListClick(TCustomListBox(PickList),
                           LCol, LRow, FGrid.CellRect(LCol, LRow),
                           LIndex, LItem,
                           FGrid.InplaceEditor);
  end;
end;

//-----------------------------------------------------------------------------
//  }EXzC[̏
//  ̏Ȃƃ}EXzC[ŃXgĂ܂
//-----------------------------------------------------------------------------
procedure TplInplaceEditList.WMMouseWheel(var Message: TWMMouseWheel);
var
  LListBox : TListBox;
begin
  LListBox := TListBox(PickList);

  if LListBox.MouseInClient then begin
    if Message.WheelDelta > 0 then begin
      LListBox.Perform(WM_VSCROLL, MakeWParam(SB_LINEUP, 0), 0);
    end else begin
      LListBox.Perform(WM_VSCROLL, MakeWParam(SB_LINEDOWN, 0), 0);
    end;
  end else begin
    // TListBox ̈Oł̃}EXzC[ TListBox ꍇ
    // ȉ̃R[hs
//    inherited;
  end;
end;

//-----------------------------------------------------------------------------
//  R|[lgo^
//-----------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('plXRAY', [TplDropStringGrid]);
end;

end.

